<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE sect1 PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
   "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
  <!ENTITY % general-entities SYSTEM "../../general.ent">
  %general-entities;

  <!ENTITY libcddb-download-http "&sourceforge-dl;/libcddb/libcddb-&libcddb-version;.tar.bz2">
  <!ENTITY libcddb-download-ftp  " ">
  <!ENTITY libcddb-md5sum        "8bb4a6f542197e8e9648ae597cd6bc8a">
  <!ENTITY libcddb-size          "384 KB">
  <!ENTITY libcddb-buildsize     "3.9 MB (with tests)">
  <!ENTITY libcddb-time          "0.2 SBU (with tests)">
]>

<sect1 id="libcddb" xreflabel="libcddb-&libcddb-version;">
  <?dbhtml filename="libcddb.html"?>


  <title>libcddb-&libcddb-version;</title>

  <indexterm zone="libcddb">
    <primary sortas="a-libcddb">libcddb</primary>
  </indexterm>

  <sect2 role="package">
    <title>Introduction to libcddb</title>

    <para>
      The <application>libcddb</application> is a library that implements
      the different protocols (CDDBP, HTTP, SMTP) to access data on a CDDB
      server.
    </para>

    &lfs122_checked;

    <bridgehead renderas="sect3">Package Information</bridgehead>
    <itemizedlist spacing="compact">
      <listitem>
        <para>
          Download (HTTP): <ulink url="&libcddb-download-http;"/>
        </para>
      </listitem>
      <listitem>
        <para>
          Download (FTP): <ulink url="&libcddb-download-ftp;"/>
        </para>
      </listitem>
      <listitem>
        <para>
          Download MD5 sum: &libcddb-md5sum;
        </para>
      </listitem>
      <listitem>
        <para>
          Download size: &libcddb-size;
        </para>
      </listitem>
      <listitem>
        <para>
          Estimated disk space required: &libcddb-buildsize;
        </para>
      </listitem>
      <listitem>
        <para>
          Estimated build time: &libcddb-time;
        </para>
      </listitem>
    </itemizedlist>

    &test-use-internet;

  </sect2>

  <sect2 role="installation">
    <title>Installation of libcddb</title>

    <para>
      By default this package accesses
      <systemitem class='domainname'>freedb.org</systemitem>, which is
      already closed.  Modify the default to use
      <systemitem class='domainname'>gnudb.gnudb.org</systemitem> instead,
      and fix two stale test data files:
    </para>

<screen><userinput>sed -e '/DEFAULT_SERVER/s/freedb.org/gnudb.gnudb.org/' \
    -e '/DEFAULT_PORT/s/888/&amp;0/'                       \
    -i include/cddb/cddb_ni.h                          &amp;&amp;
sed '/^Genre:/s/Trip-Hop/Electronic/' -i tests/testdata/920ef00b.txt &amp;&amp;
sed '/DISCID/i# Revision: 42'         -i tests/testcache/misc/12340000</userinput></screen>

    <para>
      Fix a problem building with gcc-14 and later:
    </para>

<screen><userinput>sed -i 's/size_t l;/socklen_t l;/' lib/cddb_net.c</userinput></screen>

    <para>
      Install <application>libcddb</application> by running the
      following commands:
    </para>

<screen><userinput>./configure --prefix=/usr --disable-static &amp;&amp;
make</userinput></screen>

    <para>
      To test the results, issue: <command>make check -k</command>.
      The test suite needs the Internet connection.  One test fails due to
      missing test server.
    </para>

    <para>
      Now, as the <systemitem class="username">root</systemitem> user:
    </para>

<screen role="root"><userinput>make install</userinput></screen>

  </sect2>

  <sect2 role="content">
    <title>Contents</title>

    <segmentedlist>
      <segtitle>Installed Programs</segtitle>
      <segtitle>Installed Library</segtitle>
      <segtitle>Installed Directories</segtitle>

      <seglistitem>
        <seg>
          cddb_query
        </seg>
        <seg>
          libcddb.so
        </seg>
        <seg>
          /usr/include/cddb
        </seg>
      </seglistitem>
    </segmentedlist>

    <variablelist>
      <bridgehead renderas="sect3">Short Descriptions</bridgehead>
      <?dbfo list-presentation="list"?>
      <?dbhtml list-presentation="table"?>

      <varlistentry id="cddb_query">
        <term><command>cddb_query</command></term>
        <listitem>
          <para>
            provides a user interface to a CDDB server
          </para>
          <indexterm zone="libcddb cddb_query">
            <primary sortas="b-cddb_query">cddb_query</primary>
          </indexterm>
        </listitem>
      </varlistentry>

    </variablelist>
  </sect2>

</sect1>
